Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7465)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7466)
@@ -168,5 +168,4 @@
     grok.template('containerpage')
     label = 'Student Section'
-    title = 'Students'
     pnav = 4
 
@@ -198,5 +197,4 @@
     grok.require('waeup.Anonymous')
     grok.template('setpassword')
-    title = ''
     label = 'Set password for first-time login'
     ac_prefix = 'PWD'
@@ -266,9 +264,5 @@
     grok.template('containermanagepage')
     pnav = 4
-    title = 'Manage student section'
-
-    @property
-    def label(self):
-        return self.title
+    label = 'Manage student section'
 
     def update(self, *args, **kw):
@@ -326,5 +320,4 @@
     form_fields = grok.AutoFields(IStudent).select(
         'firstname', 'middlename', 'lastname')
-    title = 'Students'
     label = 'Add student'
     pnav = 4
@@ -348,5 +341,4 @@
     form_fields = grok.AutoFields(IStudentBase).omit('password')
     pnav = 4
-    title = 'Base Data'
 
     @property
@@ -374,5 +366,4 @@
     grok.require('waeup.viewStudent')
     pnav = 4
-    title = 'Contact'
     form_fields = grok.AutoFields(IContactForm).select('subject', 'body')
 
@@ -423,5 +414,4 @@
     grok.template('basemanagepage')
     label = 'Manage base data'
-    title = 'Base Data'
     pnav = 4
 
@@ -483,5 +473,4 @@
     form_fields = grok.AutoFields(IStudentClearance).omit('clearance_locked')
     form_fields['date_of_birth'].custom_widget = FriendlyDateDisplayWidget('le')
-    title = 'Clearance Data'
     pnav = 4
 
@@ -569,5 +558,4 @@
     form_fields = grok.AutoFields(IStudentClearance)
     label = 'Manage clearance data'
-    title = 'Clearance Data'
     pnav = 4
     form_fields['date_of_birth'].custom_widget = FriendlyDateWidget('le-year')
@@ -638,5 +626,4 @@
     form_fields = grok.AutoFields(IStudentPersonal)
     form_fields['perm_address'].custom_widget = BytesDisplayWidget
-    title = 'Personal Data'
     pnav = 4
 
@@ -661,5 +648,4 @@
     form_fields = grok.AutoFields(IStudentPersonal)
     label = 'Manage personal data'
-    title = 'Personal Data'
     pnav = 4
 
@@ -677,5 +663,4 @@
     form_fields = grok.AutoFields(IStudentStudyCourse)
     grok.template('studycoursepage')
-    title = 'Study Course'
     pnav = 4
 
@@ -720,5 +705,4 @@
     grok.template('studycoursemanagepage')
     form_fields = grok.AutoFields(IStudentStudyCourse)
-    title = 'Study Course'
     label = 'Manage study course'
     pnav = 4
@@ -798,8 +782,4 @@
         datatable.need()
         return
-
-    @property
-    def title(self):
-        return 'Study Level %s' % self.context.level_title
 
     @property
@@ -917,8 +897,4 @@
 
     @property
-    def title(self):
-        return 'Study Level %s' % self.context.level_title
-
-    @property
     def label(self):
         return 'Manage study level %s' % self.context.level_title
@@ -1020,8 +996,4 @@
         'grade', 'score', 'automatic')
     pnav = 4
-
-    @property
-    def title(self):
-        return 'Study Level %s' % self.context.level_title
 
     @action('Add course ticket')
@@ -1064,8 +1036,4 @@
 
     @property
-    def title(self):
-        return 'Course Ticket %s' % self.context.code
-
-    @property
     def label(self):
         return '%s: Course Ticket %s' % (
@@ -1089,8 +1057,4 @@
     grok.template('courseticketmanagepage')
     pnav = 4
-
-    @property
-    def title(self):
-        return 'Course Ticket %s' % self.context.code
 
     @property
@@ -1112,5 +1076,4 @@
 #    form_fields = grok.AutoFields(IStudentPaymentsContainer)
 #    grok.template('paymentspage')
-#    title = 'Payments'
 #    pnav = 4
 
@@ -1133,5 +1096,4 @@
     form_fields = grok.AutoFields(IStudentPaymentsContainer)
     grok.template('paymentsmanagepage')
-    title = 'Payments'
     pnav = 4
 
@@ -1200,5 +1162,4 @@
         'p_category')
     label = 'Add online payment'
-    title = 'Payments'
     pnav = 4
     
@@ -1259,8 +1220,4 @@
     form_fields['payment_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
     pnav = 4
-
-    @property
-    def title(self):
-        return 'Online Payment Ticket %s' % self.context.p_id
 
     @property
@@ -1384,5 +1341,4 @@
 #    form_fields = grok.AutoFields(IStudentAccommodation)
 #    #grok.template('accommodationpage')
-#    title = 'Accommodation'
 #    pnav = 4
 
@@ -1400,5 +1356,4 @@
     form_fields = grok.AutoFields(IStudentAccommodation)
     grok.template('accommodationmanagepage')
-    title = 'Accommodation'
     pnav = 4
     officers_only_actions = ['Remove selected']
@@ -1465,5 +1420,4 @@
     ac_prefix = 'HOS'
     label = 'Add bed ticket'
-    title = 'Add bed ticket'
     pnav = 4
     buttonname = 'Create bed ticket'
@@ -1565,8 +1519,4 @@
     def label(self):
         return 'Bed Ticket for Session %s' % self.context.getSessionString()
-
-    @property
-    def title(self):
-        return 'Bed Ticket %s' % self.context.getSessionString()
 
 class BedTicketSlipActionButton(ManageActionButton):
@@ -1685,5 +1635,4 @@
     grok.require('waeup.viewStudent')
     grok.template('studenthistory')
-    title = 'History'
     pnav = 4
 
@@ -1735,5 +1684,4 @@
         'email', 'phone')
     label = 'Edit base data'
-    title = 'Base Data'
     pnav = 4
 
@@ -1751,5 +1699,4 @@
     grok.template('change_password')
     label = 'Change password'
-    title = 'Base Data'
     pnav = 4
 
@@ -1778,5 +1725,4 @@
     grok.template('filesuploadpage')
     label = 'Upload portrait'
-    title = 'Base Data'
     pnav = 4
 
@@ -1808,5 +1754,4 @@
     grok.require('waeup.handleStudent')
     grok.template('enterpin')
-    title = 'Start clearance'
     label = 'Start clearance'
     ac_prefix = 'CLR'
@@ -1892,5 +1837,4 @@
         IStudentClearanceEdit).omit('clearance_locked')
     label = 'Edit clearance data'
-    title = 'Clearance Data'
     form_fields['date_of_birth'].custom_widget = FriendlyDateWidget('le-year')
 
@@ -1930,5 +1874,4 @@
     grok.require('waeup.handleStudent')
     grok.template('enterpin')
-    title = 'Request clearance'
     label = 'Request clearance'
     notice = 'Enter the CLR access code used for starting clearance.'
@@ -1977,5 +1920,4 @@
     grok.require('waeup.handleStudent')
     grok.template('enterpin')
-    title = 'Start course registration'
     label = 'Start course registration'
     ac_prefix = 'SFE'
@@ -2049,5 +1991,4 @@
     grok.template('studyleveladdpage')
     form_fields = grok.AutoFields(IStudentStudyCourse)
-    title = 'Study Course'
     pnav = 4
 
@@ -2114,8 +2055,4 @@
         warning.need()
         return
-
-    @property
-    def title(self):
-        return 'Study Level %s' % self.context.level_title
 
     @property
@@ -2203,5 +2140,4 @@
     grok.require('waeup.Anonymous')
     grok.template('changepw')
-    title = 'Change Password Request'
     label = 'Change my password'
     form_fields = grok.AutoFields(IStudentChangePassword)