Index: main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/browser.py	(revision 7466)
+++ main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/browser.py	(revision 7467)
@@ -42,5 +42,5 @@
     grok.require('waeup.manageACBatches')
 
-    title = 'Access Code Batches'
+    label = 'Access Code Batches'
     pnav = 0
 
@@ -98,5 +98,5 @@
     grok.require('waeup.manageACBatches')
 
-    title = 'Reimport Access Code Batches'
+    label = 'Reimport Access Code Batches'
     pnav = 0
 
@@ -129,8 +129,6 @@
     grok.template('searchpage')
     grok.require('waeup.manageACBatches')
-
-    title = 'Access Codes'
-    pnav = 0
-    label = 'Search and manage access codes'
+    pnav = 0
+    label = 'Search and Manage Access Codes'
 
     def update(self, *args, **kw):
Index: main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/browser_templates/batchcontainer.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/browser_templates/batchcontainer.pt	(revision 7466)
+++ main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/browser_templates/batchcontainer.pt	(revision 7467)
@@ -1,4 +1,2 @@
-<h2>Access Code Batches</h2>
-
 <form method="POST">
   <p>
Index: main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/browser_templates/reimportbatchpage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/browser_templates/reimportbatchpage.pt	(revision 7466)
+++ main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/browser_templates/reimportbatchpage.pt	(revision 7467)
@@ -1,3 +1,2 @@
-<h3>Reimport Access Code Batches</h3>
 <p> Please select the files to reimport. Please note, that batches with  same name have to be deleted before.
 </p>
Index: main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 7466)
+++ main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 7467)
@@ -60,5 +60,4 @@
     grok.name('index')
     grok.require('waeup.Public')
-    title = 'Applicants'
     label = 'Application Section'
     pnav = 3
@@ -73,5 +72,4 @@
     grok.name('manage')
     grok.template('applicantsrootmanagepage')
-    title = 'Applicants'
     label = 'Manage application section'
     pnav = 3
@@ -144,5 +142,4 @@
     grok.name('add')
     grok.template('applicantscontaineraddpage')
-    title = 'Applicants'
     label = 'Add applicants container'
     pnav = 3
@@ -229,10 +226,6 @@
 
     @property
-    def title(self):
+    def label(self):
         return "Applicants Container: %s" % self.context.title
-
-    @property
-    def label(self):
-        return self.context.title
 
 class ApplicantsContainerManageFormPage(SIRPEditFormPage):
@@ -251,8 +244,4 @@
 
     @property
-    def title(self):
-        return "Applicants Container: %s" % self.context.title
-
-    @property
     def label(self):
         return 'Manage applicants container'
@@ -342,8 +331,4 @@
     pnav = 3
 
-    @property
-    def title(self):
-        return "Applicants Container: %s" % self.context.title
-
     @action('Create application record')
     def addApplicant(self, **data):
@@ -381,8 +366,4 @@
             return 'set'
         return 'unset'
-
-    @property
-    def title(self):
-        return 'Application Record %s' % self.context.application_number
 
     @property
@@ -486,8 +467,4 @@
 
     @property
-    def title(self):
-        return 'Online Payment Ticket %s' % self.context.p_id
-
-    @property
     def label(self):
         return '%s: Online Payment Ticket %s' % (
@@ -650,8 +627,4 @@
                 upload, self.context, self)
         return
-
-    @property
-    def title(self):
-        return 'Application Record %s' % self.context.application_number
 
     @property
@@ -767,5 +740,4 @@
     grok.template('applicanteditpage')
     manage_applications = False
-    title = u'Your Application Form'
 
     @property
@@ -879,8 +851,4 @@
         'firstname', 'middlename', 'lastname', 'email', 'phone')
     form_fields['phone'].custom_widget = PhoneWidget
-
-    @property
-    def title(self):
-        return "Applicants Container: %s" % self.context.title
 
     @property
@@ -936,5 +904,4 @@
     grok.require('waeup.Public')
     grok.template('applicantregemailsent')
-    title = 'Registration Completed'
     label = 'Your registration was successful'
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/hostels/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/hostels/browser.py	(revision 7466)
+++ main/waeup.sirp/trunk/src/waeup/sirp/hostels/browser.py	(revision 7467)
@@ -100,5 +100,4 @@
     grok.template('containerpage')
     label = 'Accommodation Section'
-    title = 'Hostels'
     pnav = 5
 
@@ -118,5 +117,4 @@
     grok.template('containermanagepage')
     pnav = 5
-    title = 'Hostels'
     label = 'Manage accommodation section'
 
@@ -154,5 +152,4 @@
     #grok.template('hosteladdpage')
     form_fields = grok.AutoFields(IHostel)
-    title = 'Hostels'
     label = 'Add hostel'
     pnav = 5
@@ -187,8 +184,4 @@
         return self.context.hostel_name
 
-    @property
-    def title(self):
-        return self.context.hostel_name
-
 class HostelManageActionButton(ManageActionButton):
     grok.order(1)
@@ -214,8 +207,4 @@
         'Release selected beds']
     not_occupied = NOT_OCCUPIED
-
-    @property
-    def title(self):
-        return self.context.hostel_name
 
     @property
@@ -310,10 +299,4 @@
     pnav = 5
 
-    @property
-    def title(self):
-        co = self.context.getBedCoordinates()
-        return '%s, Block %s, Room %s, Bed %s' % (
-            self.context.__parent__.hostel_name, co[1], co[2], co[3])
-
     @action('Save')
     def save(self, **data):