Index: main/waeup.sirp/trunk/src/waeup/sirp/widgets/tests/test_phonewidget.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/widgets/tests/test_phonewidget.py	(revision 7440)
+++ main/waeup.sirp/trunk/src/waeup/sirp/widgets/tests/test_phonewidget.py	(revision 7494)
@@ -126,14 +126,14 @@
         self.assertEqual(
             self.widget(),
-            (u'+&nbsp;<input class="textType" id="field.foo.country"'
-             u' name="field.foo.country" size="3" type="text" value="123" '
-             u' />'
-             u'&nbsp;-\n'
-             u'<input class="textType" id="field.foo.area"'
-             u' name="field.foo.area" size="5" type="text" value="456" '
-             u' />'
-             u'&nbsp;-\n'
-             u'<input class="textType" id="field.foo.extension"'
-             u' name="field.foo.extension" size="10" type="text"'
+            (u'+&nbsp;<input class="span2 textType" id="field.foo.country"'
+             u' name="field.foo.country" size="20" type="text" value="123" '
+             u' />'
+             u'&nbsp;-\n'
+             u'<input class="span2 textType" id="field.foo.area"'
+             u' name="field.foo.area" size="20" type="text" value="456" '
+             u' />'
+             u'&nbsp;-\n'
+             u'<input class="span3 textType" id="field.foo.extension"'
+             u' name="field.foo.extension" size="20" type="text"'
              u' value="1234567"  />\n'))
         return
@@ -288,13 +288,13 @@
         self.assertEqual(
             self.widget.hidden(),
-            (u'<input class="hiddenType" id="field.foo.country"'
+            (u'<input class="span2 hiddenType" id="field.foo.country"'
              u' name="field.foo.country" type="hidden" value="123" '
              u' />'
              u'\n'
-             u'<input class="hiddenType" id="field.foo.area"'
+             u'<input class="span2 hiddenType" id="field.foo.area"'
              u' name="field.foo.area" type="hidden" value="456" '
              u' />'
              u'\n'
-             u'<input class="hiddenType" id="field.foo.extension"'
+             u'<input class="span3 hiddenType" id="field.foo.extension"'
              u' name="field.foo.extension" type="hidden"'
              u' value="1234567"  />'))
@@ -378,14 +378,14 @@
         self.assertEqual(
             widget(),
-            (u'+&nbsp;<input class="textType" id="field.foo.country"'
-             u' name="field.foo.country" size="3" type="text" value="11" '
-             u' />'
-             u'&nbsp;-\n'
-             u'<input class="textType" id="field.foo.area"'
-             u' name="field.foo.area" size="5" type="text" value="222" '
-             u' />'
-             u'&nbsp;-\n'
-             u'<input class="textType" id="field.foo.extension"'
-             u' name="field.foo.extension" size="10" type="text"'
+            (u'+&nbsp;<input class="span2 textType" id="field.foo.country"'
+             u' name="field.foo.country" size="20" type="text" value="11" '
+             u' />'
+             u'&nbsp;-\n'
+             u'<input class="span2 textType" id="field.foo.area"'
+             u' name="field.foo.area" size="20" type="text" value="222" '
+             u' />'
+             u'&nbsp;-\n'
+             u'<input class="span3 textType" id="field.foo.extension"'
+             u' name="field.foo.extension" size="20" type="text"'
              u' value="3333"  />\n'))
         return
@@ -401,14 +401,14 @@
         self.assertEqual(
             widget(),
-            (u'+&nbsp;<input class="textType" id="field.foo.country"'
-             u' name="field.foo.country" size="3" type="text" value="11" '
-             u' />'
-             u'&nbsp;-\n'
-             u'<input class="textType" id="field.foo.area"'
-             u' name="field.foo.area" size="5" type="text" value="222" '
-             u' />'
-             u'&nbsp;-\n'
-             u'<input class="textType" id="field.foo.extension"'
-             u' name="field.foo.extension" size="10" type="text"'
+            (u'+&nbsp;<input class="span2 textType" id="field.foo.country"'
+             u' name="field.foo.country" size="20" type="text" value="11" '
+             u' />'
+             u'&nbsp;-\n'
+             u'<input class="span2 textType" id="field.foo.area"'
+             u' name="field.foo.area" size="20" type="text" value="222" '
+             u' />'
+             u'&nbsp;-\n'
+             u'<input class="span3 textType" id="field.foo.extension"'
+             u' name="field.foo.extension" size="20" type="text"'
              u' value="3333"  />\n'))
         return
@@ -485,14 +485,14 @@
         self.assertEqual(
             self.widget(),
-            (u'+&nbsp;<input class="textType" id="field.foo.country"'
-             u' name="field.foo.country" size="3" type="text" value="" '
-             u' />'
-             u'&nbsp;-\n'
-             u'<input class="textType" id="field.foo.area"'
-             u' name="field.foo.area" size="5" type="text" value="" '
-             u' />'
-             u'&nbsp;-\n'
-             u'<input class="textType" id="field.foo.extension"'
-             u' name="field.foo.extension" size="10" type="text"'
+            (u'+&nbsp;<input class="span2 textType" id="field.foo.country"'
+             u' name="field.foo.country" size="20" type="text" value="" '
+             u' />'
+             u'&nbsp;-\n'
+             u'<input class="span2 textType" id="field.foo.area"'
+             u' name="field.foo.area" size="20" type="text" value="" '
+             u' />'
+             u'&nbsp;-\n'
+             u'<input class="span3 textType" id="field.foo.extension"'
+             u' name="field.foo.extension" size="20" type="text"'
              u' value=""  />\n'))
         return