Index: main/waeup.sirp/trunk/src/waeup/sirp/students/batching.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/batching.py	(revision 7491)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/batching.py	(revision 7497)
@@ -32,5 +32,5 @@
 from zope.catalog.interfaces import ICatalog
 from waeup.sirp.interfaces import (
-    IBatchProcessor, FatalCSVError, IObjectConverter)
+    IBatchProcessor, FatalCSVError, IObjectConverter, IUserAccount)
 from waeup.sirp.students.interfaces import (
     IStudent, IStudentStudyCourseImport,
@@ -58,5 +58,5 @@
     def available_fields(self):
         return sorted(list(set(
-            ['student_id','reg_number','matric_number'] + getFields(
+            ['student_id','reg_number','matric_number','password'] + getFields(
                 self.iface).keys())))
 
@@ -137,4 +137,15 @@
         pass
 
+    def updateEntry(self, obj, row, site):
+        """Update obj to the values given in row.
+        """
+        for key, value in row.items():
+            # Set student password and all fields declared in interface.
+            if key == 'password':
+                IUserAccount(obj).setPassword(value)
+            elif hasattr(obj, key):
+                setattr(obj, key, value)
+        return
+
     def getMapping(self, path, headerfields, mode):
         """Get a mapping from CSV file headerfields to actually used fieldnames.
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/sample_student_data_migration.csv
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/sample_student_data_migration.csv	(revision 7491)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/sample_student_data_migration.csv	(revision 7497)
@@ -1,4 +1,4 @@
-student_id,firstname,lastname,reg_number,date_of_birth,matric_number,email,phone
-A123456,Aaren,Pieri,1,1990-01-02,100000,aa@aa.ng,1234
-B123456,Aaren,Finau,2,1990-01-03,100001,aa@aa.ng,1234
-C123456,Aaren,Berson,3,1990-01-04,100002,aa@aa.ng,1234
+student_id,firstname,lastname,reg_number,date_of_birth,matric_number,email,phone,password
+A123456,Aaren,Pieri,1,1990-01-02,100000,aa@aa.ng,1234,mypw1
+B123456,Aaren,Finau,2,1990-01-03,100001,aa@aa.ng,1234,mypw1
+C123456,Aaren,Berson,3,1990-01-04,100002,aa@aa.ng,1234,mypw1
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py	(revision 7491)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py	(revision 7497)
@@ -682,8 +682,8 @@
         # Prepare a csv file for students
         open('students.csv', 'wb').write(
-"""firstname,lastname,reg_number,date_of_birth,matric_number,email,phone
-Aaren,Pieri,1,1990-01-02,100000,aa@aa.ng,1234
-Claus,Finau,2,1990-01-03,100001,aa@aa.ng,1234
-Brit,Berson,3,1990-01-04,100001,aa@aa.ng,1234
+"""firstname,lastname,reg_number,date_of_birth,matric_number,email,phone,password
+Aaren,Pieri,1,1990-01-02,100000,aa@aa.ng,1234,mypwd1
+Claus,Finau,2,1990-01-03,100001,aa@aa.ng,1234,mypwd1
+Brit,Berson,3,1990-01-04,100001,aa@aa.ng,1234,mypwd1
 """)
         self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
@@ -739,9 +739,19 @@
         # The students are properly indexed and we can
         # thus find a student in  the department
-        self.browser.open(self.container_path)
+        self.browser.open(self.manage_container_path)
         self.browser.getControl(name="searchtype").value = ['depcode']
         self.browser.getControl(name="searchterm").value = 'dep1'
         self.browser.getControl("Search").click()
         self.assertTrue('Aaren Pieri' in self.browser.contents)
+        # We can search for a new student by name ...
+        self.browser.getControl(name="searchtype").value = ['fullname']
+        self.browser.getControl(name="searchterm").value = 'Claus'
+        self.browser.getControl("Search").click()
+        self.assertTrue('Claus Finau' in self.browser.contents)
+        # ... and check if the imported password has been properly set
+        ctrl = self.browser.getControl(name='entries')
+        value = ctrl.options[0]
+        claus = self.app['students'][value]
+        self.assertTrue(IUserAccount(claus).checkPassword('mypwd1'))
         return
 