Index: main/waeup.custom/trunk/src/waeup/custom/browser/static/custom_theme_1.css
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/browser/static/custom_theme_1.css	(revision 7504)
+++ main/waeup.custom/trunk/src/waeup/custom/browser/static/custom_theme_1.css	(revision 7505)
@@ -1,9 +1,0 @@
-.uni-logo {
-  background-image: url("custom-logo.png");
-  background-position: 0 13px;
-  background-repeat: no-repeat;
-  padding-bottom: 18px;
-  padding-left: 0;
-  padding-right: 135px;
-  padding-top: 40px;
-}
Index: main/waeup.custom/trunk/src/waeup/custom/interfaces.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/interfaces.py	(revision 7504)
+++ main/waeup.custom/trunk/src/waeup/custom/interfaces.py	(revision 7505)
@@ -18,5 +18,5 @@
 from zope import schema
 from waeup.sirp.interfaces import (
-    ISIRPObject, ISessionConfiguration, academic_sessions_vocab)
+    ISessionConfiguration, academic_sessions_vocab)
 
 # It's recommended to replicate all fields from the base package here.
Index: main/waeup.custom/trunk/src/waeup/custom/students/browser.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/students/browser.py	(revision 7505)
+++ main/waeup.custom/trunk/src/waeup/custom/students/browser.py	(revision 7505)
@@ -0,0 +1,30 @@
+## $Id$
+##
+## Copyright (C) 2012 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+import grok
+from zope.formlib.textwidgets import BytesDisplayWidget
+from waeup.custom.students.interfaces import IStudent, IStudentPersonal
+from waeup.sirp.students.browser import StudentPersonalDisplayFormPage
+
+class StudentPersonalDisplayFormPage(StudentPersonalDisplayFormPage):
+    """ Page to display student personal data
+    """
+    grok.context(IStudent)
+    form_fields = grok.AutoFields(IStudentPersonal)
+    form_fields['perm_address'].custom_widget = BytesDisplayWidget
+
+
Index: main/waeup.custom/trunk/src/waeup/custom/students/interfaces.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/students/interfaces.py	(revision 7505)
+++ main/waeup.custom/trunk/src/waeup/custom/students/interfaces.py	(revision 7505)
@@ -0,0 +1,78 @@
+## $Id$
+##
+## Copyright (C) 2012 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+from zope import schema
+from waeup.sirp.interfaces import SimpleSIRPVocabulary
+from waeup.sirp.students.interfaces import (
+    IStudentBase,IStudentClearance,IStudentPersonal,IStudentNavigation,
+    )
+
+class IStudentPersonal(IStudentPersonal):
+    """Student personal data.
+
+    """
+    perm_address = schema.Text(
+        title = u'Permanent Address',
+        required = False,
+        )
+
+    marit_stat = schema.Choice(
+        title = u'Maritual Status',
+        default = 'unmarried',
+        required = False,
+        vocabulary = SimpleSIRPVocabulary(
+            ('Unmarried', 'unmarried'),
+            ('Married', 'married'),)
+        )
+
+class IStudentClearance(IStudentClearance):
+    """Representation of student clearance data.
+
+    """
+    date_of_birth = schema.Date(
+        title = u'Date of Birth',
+        required = True,
+        )
+
+    clearance_locked = schema.Bool(
+        title = u'Clearance form locked',
+        default = False,
+        )
+
+    clr_code = schema.TextLine(
+        title = u'CLR Activation Code',
+        default = u'',
+        required = False,
+        readonly = True,
+        )
+
+class IStudent(IStudentBase,IStudentClearance,IStudentPersonal):
+    """Representation of a student.
+
+    """
+
+# Interfaces for students only
+
+class IStudentClearanceEdit(IStudentClearance):
+    """Interface needed for restricted editing of student clearance data.
+
+    """
+
+class IStudentPersonalEdit(IStudentPersonal):
+    """Interface needed for restricted editing of student personal data.
+
+    """
Index: main/waeup.custom/trunk/src/waeup/custom/students/student.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/students/student.py	(revision 7505)
+++ main/waeup.custom/trunk/src/waeup/custom/students/student.py	(revision 7505)
@@ -0,0 +1,53 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+"""
+Container for the various objects owned by students.
+"""
+import grok
+from zope.interface import implementedBy
+from waeup.sirp.utils.helpers import attrs_to_fields
+from waeup.sirp.students.student import Student, StudentFactory
+from waeup.custom.students.interfaces import (
+    IStudent, IStudentNavigation,
+    IStudentPersonalEdit, IStudentClearanceEdit)
+
+
+class Student(Student):
+    """This is a student container for the various objects
+    owned by students.
+    """
+    grok.implements(IStudent, IStudentNavigation,
+        IStudentPersonalEdit, IStudentClearanceEdit)
+    grok.provides(IStudent)
+
+
+# Set all attributes of Student required in IStudent as field
+# properties. Doing this, we do not have to set initial attributes
+# ourselves and as a bonus we get free validation when an attribute is
+# set.
+Student = attrs_to_fields(Student)
+
+class StudentFactory(StudentFactory):
+    """A factory for students.
+    """
+
+    def __call__(self, *args, **kw):
+        return Student()
+
+    def getInterfaces(self):
+        return implementedBy(Student)