Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/sample_student_data.csv
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/sample_student_data.csv	(revision 7510)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/sample_student_data.csv	(revision 7513)
@@ -1,4 +1,5 @@
-firstname,lastname,reg_number,date_of_birth,matric_number,email,phone
+firstname,lastname,reg_number,date_of_birth,matric_number,email,phone,reg_state
 Aaren,Pieri,1,1990-01-02,100000,aa@aa.ng,1234
-Aaren,Finau,2,1990-01-03,100001,aa@aa.ng,1234
-Aaren,Berson,3,1990-01-04,100002,aa@aa.ng,1234
+Aaren,Finau,2,1990-01-03,100001,aa@aa.ng,1234,admitted
+Aaren,Berson,3,1990-01-04,100002,aa@aa.ng,1234,cleared
+John,Wolter,4,1990-01-04,100003,aa@aa.ng,1234,nonsense
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/sample_student_data_migration.csv
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/sample_student_data_migration.csv	(revision 7510)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/sample_student_data_migration.csv	(revision 7513)
@@ -1,4 +1,5 @@
-student_id,firstname,lastname,reg_number,date_of_birth,matric_number,email,phone,password
-A123456,Aaren,Pieri,1,1990-01-02,100000,aa@aa.ng,1234,mypw1
-B123456,Aaren,Finau,2,1990-01-03,100001,aa@aa.ng,1234,mypw1
-C123456,Aaren,Berson,3,1990-01-04,100002,aa@aa.ng,1234,mypw1
+student_id,firstname,lastname,reg_number,date_of_birth,matric_number,email,phone,password,reg_state
+A123456,Aaren,Pieri,1,1990-01-02,100000,aa@aa.ng,1234,mypw1,school fee paid
+B123456,Aaren,Finau,2,1990-01-03,100001,aa@aa.ng,1234,mypw1,cleared
+C123456,Aaren,Berson,3,1990-01-04,100002,aa@aa.ng,1234,mypw1,admitted
+D123456,John,Wolter,4,1990-01-04,100003,aa@aa.ng,1234,mypw1,nonsense
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_batching.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_batching.py	(revision 7510)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_batching.py	(revision 7513)
@@ -162,5 +162,5 @@
         num, num_warns, fin_file, fail_file = self.importer.doImport(
             self.csv_file, STUDENT_HEADER_FIELDS)
-        self.assertEqual(num_warns,0)
+        self.assertEqual(num_warns,1)
         assert len(self.app['students'].keys()) == 4
         shutil.rmtree(os.path.dirname(fin_file))
@@ -196,7 +196,8 @@
         num, num_warns, fin_file, fail_file = self.importer.doImport(
             self.csv_file_migration, STUDENT_HEADER_FIELDS_MIGRATION)
-        self.assertEqual(num_warns,0)
+        self.assertEqual(num_warns,1)
         assert len(self.app['students'].keys()) == 4
         self.assertTrue('A123456' in self.app['students'].keys())
+        self.assertEqual(self.app['students']['A123456'].state,'school fee paid')
         shutil.rmtree(os.path.dirname(fin_file))
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py	(revision 7510)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py	(revision 7513)
@@ -31,5 +31,5 @@
 from zope.securitypolicy.interfaces import IPrincipalRoleManager
 from zope.testbrowser.testing import Browser
-from hurry.workflow.interfaces import IWorkflowInfo
+from hurry.workflow.interfaces import IWorkflowInfo, IWorkflowState
 from waeup.sirp.testing import FunctionalLayer, FunctionalTestCase
 from waeup.sirp.app import University
@@ -769,6 +769,5 @@
         prmlocal = IPrincipalRoleManager(department)
         prmlocal.assignRoleToPrincipal('waeup.local.ClearanceOfficer', 'mrclear')
-        IWorkflowInfo(self.student).fireTransition('admit')
-        IWorkflowInfo(self.student).fireTransition('start_clearance')
+        IWorkflowState(self.student).setState('clearance started')
         # Login as clearance officer
         self.browser.open(self.login_path)
@@ -857,9 +856,5 @@
         prmlocal = IPrincipalRoleManager(cert)
         prmlocal.assignRoleToPrincipal('waeup.local.CourseAdviser100', 'mrsadvise')
-        IWorkflowInfo(self.student).fireTransition('admit')
-        IWorkflowInfo(self.student).fireTransition('start_clearance')
-        IWorkflowInfo(self.student).fireTransition('request_clearance')
-        IWorkflowInfo(self.student).fireTransition('clear')
-        IWorkflowInfo(self.student).fireTransition('pay_first_school_fee')
+        IWorkflowState(self.student).setState('school fee paid')
         # Login as course adviser
         self.browser.open(self.login_path)