Index: main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 7522)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 7523)
@@ -25,5 +25,6 @@
 from waeup.sirp.students.vocabularies import (
   CertificateSource, verdicts, StudyLevelSource,
-  contextual_reg_num_source, contextual_mat_num_source, GenderSource,
+  contextual_reg_num_source, contextual_mat_num_source,
+  GenderSource, nats_vocab,
   )
 from waeup.sirp.payments.interfaces import IPaymentsContainer, IOnlinePayment
@@ -204,4 +205,11 @@
         )
 
+    nationality = schema.Choice(
+        source = nats_vocab,
+        title = u'Nationality',
+        default = 'nigeria',
+        required = True,
+        )
+
 class IStudentPersonal(ISIRPObject):
     """Representation of student personal data.
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/nats.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/nats.py	(revision 7523)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/nats.py	(revision 7523)
@@ -0,0 +1,253 @@
+NATS = (
+    ('nigeria','Nigeria'),
+    ('afghanistan','Afghanistan'),
+    ('albania','Albania'),
+    ('algeria','Algeria'),
+    ('american_samoa','American Samoa'),
+    ('andorra','Andorra'),
+    ('angola','Angola'),
+    ('anguilla','Anguilla'),
+    ('antarctica','Antarctica'),
+    ('antigua_and_barbuda','Antigua And Barbuda'),
+    ('argentina','Argentina'),
+    ('armenia','Armenia'),
+    ('aruba','Aruba'),
+    ('ascension_island','Ascension Island'),
+    ('australia','Australia'),
+    ('austria','Austria'),
+    ('azerbaijan','Azerbaijan'),
+    ('bahamas','Bahamas'),
+    ('bahrain','Bahrain'),
+    ('bangladesh','Bangladesh'),
+    ('barbados','Barbados'),
+    ('belarus','Belarus'),
+    ('belgium','Belgium'),
+    ('belize','Belize'),
+    ('benin','Benin'),
+    ('bermuda','Bermuda'),
+    ('bhutan','Bhutan'),
+    ('bolivia','Bolivia'),
+    ('bosnia_and_herzegovina','Bosnia And Herzegovina'),
+    ('botswana','Botswana'),
+    ('bouvet_island','Bouvet Island'),
+    ('brazil','Brazil'),
+    ('british_indian_ocean_territory','British Indian Ocean Territory'),
+    ('british_virgin_islands','British Virgin Islands'),
+    ('brunei_darussalam','Brunei Darussalam'),
+    ('bulgaria','Bulgaria'),
+    ('burkina_faso','Burkina Faso'),
+    ('burma','Burma'),
+    ('burundi','Burundi'),
+    ('cambodia','Cambodia'),
+    ('cameroon','Cameroon'),
+    ('canada','Canada'),
+    ('cape_verde','Cape Verde'),
+    ('cayman_islands','Cayman Islands'),
+    ('central_african_republic','Central African Republic'),
+    ('chad','Chad'),
+    ('chile','Chile'),
+    ('china','China'),
+    ('christmas_island','Christmas Island'),
+    ('cocos_keeling_islands','Cocos (Keeling) Islands'),
+    ('colombia','Colombia'),
+    ('comoros','Comoros'),
+    ('congo_brazzaville_','Congo (Brazzaville) '),
+    ('congo_dem_rep','Congo, Democratic Republic Of'),
+    ('cook_islands','Cook Islands'),
+    ('costa_rica','Costa Rica'),
+    ('cote_d_ivoire',"Cote D'Ivoire"),
+    ('croatia','Croatia'),
+    ('cuba','Cuba'),
+    ('cyprus','Cyprus'),
+    ('czech_republic','Czech Republic'),
+    ('denmark','Denmark'),
+    ('djibouti','Djibouti'),
+    ('dominica','Dominica'),
+    ('dominican_republic','Dominican Republic'),
+    ('east_timor','East Timor'),
+    ('ecuador','Ecuador'),
+    ('egypt','Egypt'),
+    ('el_salvador','El Salvador'),
+    ('england','England'),
+    ('equatorial_guinea','Equatorial Guinea'),
+    ('eritrea','Eritrea'),
+    ('estonia','Estonia'),
+    ('ethiopia','Ethiopia'),
+    ('falkland_islands','Falkland Islands (Islas Malvinas) '),
+    ('faroe_islands','Faroe Islands'),
+    ('fiji','Fiji'),
+    ('finland','Finland'),
+    ('france','France'),
+    ('french_guiana','French Guiana'),
+    ('french_polynesia','French Polynesia'),
+    ('french_southern_territories','French Southern Territories'),
+    ('gabon','Gabon'),
+    ('gambia','Gambia, The'),
+    ('georgia','Georgia'),
+    ('germany','Germany'),
+    ('ghana','Ghana'),
+    ('gibraltar','Gibraltar'),
+    ('greece','Greece'),
+    ('greenland_denmark_','Greenland (Denmark) '),
+    ('grenada','Grenada'),
+    ('guadeloupe','Guadeloupe'),
+    ('guam','Guam'),
+    ('guatemala','Guatemala'),
+    ('guinea','Guinea'),
+    ('guinea-bissau','Guinea-Bissau'),
+    ('guyana','Guyana'),
+    ('haiti','Haiti'),
+    ('heard_and_mcdonald_islands','Heard And McDonald Islands'),
+    ('honduras','Honduras'),
+    ('hong_kong','Hong Kong (Special Admin Region Of China) '),
+    ('hungary','Hungary'),
+    ('iceland','Iceland'),
+    ('india','India'),
+    ('indonesia','Indonesia'),
+    ('iran','Iran'),
+    ('iraq','Iraq'),
+    ('ireland','Ireland'),
+    ('isle_of_man','Isle Of Man'),
+    ('israel','Israel'),
+    ('italy','Italy'),
+    ('jamaica','Jamaica'),
+    ('japan','Japan'),
+    ('johnston_atoll','Johnston Atoll'),
+    ('jordan','Jordan'),
+    ('kazakhstan','Kazakhstan'),
+    ('kenya','Kenya'),
+    ('kiribati','Kiribati'),
+    ('korea_north_','Korea, Democratic People S Republic Of (North) '),
+    ('korea_south_','Korea, Republic Of (South) '),
+    ('kuwait','Kuwait'),
+    ('kyrgyzstan','Kyrgyzstan'),
+    ('laos_','Lao People S Democratic Republic (Laos) '),
+    ('latvia','Latvia'),
+    ('lebanon','Lebanon'),
+    ('lesotho','Lesotho'),
+    ('liberia','Liberia'),
+    ('libya','Libyan Arab Jamahiriya'),
+    ('liechtenstein','Liechtenstein'),
+    ('lithuania','Lithuania'),
+    ('luxembourg','Luxembourg'),
+    ('macau','Macau (Special Admin Region Of China) '),
+    ('macedonia','Macedonia, Former Yugoslav Republic Of'),
+    ('madagascar','Madagascar'),
+    ('malawi','Malawi'),
+    ('malaysia','Malaysia'),
+    ('maldives','Maldives'),
+    ('mali','Mali'),
+    ('malta','Malta'),
+    ('marshall_islands','Marshall Islands'),
+    ('martinique','Martinique'),
+    ('mauritania','Mauritania'),
+    ('mauritius','Mauritius'),
+    ('mayotte','Mayotte'),
+    ('mexico','Mexico'),
+    ('micronesia','Micronesia, Federated States Of'),
+    ('midway_islands','Midway Islands'),
+    ('moldova','Moldova, Republic Of'),
+    ('monaco','Monaco'),
+    ('mongolia','Mongolia'),
+    ('montserrat','Montserrat'),
+    ('morocco','Morocco'),
+    ('mozambique','Mozambique'),
+    ('myanmar','Myanmar'),
+    ('namibia','Namibia'),
+    ('nauru','Nauru'),
+    ('nepal','Nepal'),
+    ('netherlands','Netherlands'),
+    ('netherlands_antilles','Netherlands Antilles'),
+    ('new_caledonia','New Caledonia'),
+    ('new_zealand','New Zealand'),
+    ('nicaragua','Nicaragua'),
+    ('niger','Niger'),
+    ('niue','Niue'),
+    ('norfolk_island','Norfolk Island'),
+    ('northern_mariana_islands','Northern Mariana Islands'),
+    ('norway','Norway'),
+    ('oman','Oman'),
+    ('pakistan','Pakistan'),
+    ('palau','Palau'),
+    ('palestinian_territory','Palestinian Territory, Occupied'),
+    ('panama','Panama'),
+    ('papua_new_guinea','Papua New Guinea'),
+    ('paraguay','Paraguay'),
+    ('peru','Peru'),
+    ('philippines','Philippines'),
+    ('pitcairn_islands','Pitcairn Islands'),
+    ('poland','Poland'),
+    ('portugal','Portugal'),
+    ('puerto_rico','Puerto Rico'),
+    ('qatar','Qatar'),
+    ('reunion','Reunion'),
+    ('romania','Romania'),
+    ('russian_federation','Russian Federation'),
+    ('rwanda','Rwanda'),
+    ('saint_helena_island','Saint Helena Island'),
+    ('saint_kitts_and_nevis','Saint Kitts And Nevis'),
+    ('saint_lucia','Saint Lucia'),
+    ('saint_pierre_and_miquelon','Saint Pierre And Miquelon'),
+    ('saint_vincent_and_the_grenadines','Saint Vincent And The Grenadines'),
+    ('samoa','Samoa'),
+    ('san_marino','San Marino'),
+    ('sao_tome_and_principe','Sao Tome And Principe'),
+    ('saudi_arabia','Saudi Arabia'),
+    ('scotland','Scotland'),
+    ('senegal','Senegal'),
+    ('seychelles','Seychelles'),
+    ('sierra_leone','Sierra Leone'),
+    ('singapore','Singapore'),
+    ('slovakia','Slovakia'),
+    ('slovenia','Slovenia'),
+    ('solomon_islands','Solomon Islands'),
+    ('somalia','Somalia'),
+    ('south_africa','South Africa'),
+    ('south_georgia_south_sandwich_islands','South Georgia And South Sandwich Islands'),
+    ('spain','Spain'),
+    ('sri_lanka','Sri Lanka'),
+    ('sudan','Sudan'),
+    ('suriname','Suriname'),
+    ('svalbard_and_jan_mayen','Svalbard And Jan Mayen'),
+    ('swaziland','Swaziland'),
+    ('sweden','Sweden'),
+    ('switzerland','Switzerland'),
+    ('syrian_arab_republic','Syrian Arab Republic'),
+    ('taiwan','Taiwan'),
+    ('tajikistan','Tajikistan'),
+    ('tanzania','Tanzania, United Republic Of'),
+    ('thailand','Thailand'),
+    ('tibet','Tibet'),
+    ('togo','Togo'),
+    ('tokelau','Tokelau'),
+    ('tonga','Tonga'),
+    ('trinidad_and_tobago','Trinidad And Tobago'),
+    ('tunisia','Tunisia'),
+    ('turkey','Turkey'),
+    ('turkmenistan','Turkmenistan'),
+    ('turks_and_caicos','Turks And Caicos'),
+    ('tuvalu','Tuvalu'),
+    ('uganda','Uganda'),
+    ('ukraine','Ukraine'),
+    ('united_arab_emirates','United Arab Emirates'),
+    ('united_kingdom','United Kingdom'),
+    ('united_states','United States'),
+    ('united_states_minor_outlying_islands','United States Minor Outlying Islands'),
+    ('united_states_virgin_islands','United States Virgin Islands'),
+    ('uruguay','Uruguay'),
+    ('uzbekistan','Uzbekistan'),
+    ('vanuatu','Vanuatu'),
+    ('vatican_city','Vatican City'),
+    ('venezuela','Venezuela'),
+    ('vietnam','Vietnam'),
+    ('wake_island','Wake Island'),
+    ('wales','Wales'),
+    ('wallis_and_futuna','Wallis And Futuna'),
+    ('western_sahara','Western Sahara'),
+    ('western_samoa','Western Samoa'),
+    ('yemen','Yemen'),
+    ('serbia','Serbia'),
+    ('montenegro','Montenegro'),
+    ('zambia','Zambia'),
+    ('zimbabwe','Zimbabwe'),
+    )
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/vocabularies.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/vocabularies.py	(revision 7522)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/vocabularies.py	(revision 7523)
@@ -27,8 +27,12 @@
 from waeup.sirp.interfaces import SimpleSIRPVocabulary
 from waeup.sirp.students.lgas import LGAS
+from waeup.sirp.students.nats import NATS
 from waeup.sirp.university.vocabularies import course_levels
 
 lgas_vocab = SimpleSIRPVocabulary(
     *sorted([(x[1],x[0]) for x in LGAS]))
+
+nats_vocab = SimpleSIRPVocabulary(
+    *sorted([(x[1],x[0]) for x in NATS]))
 
 def study_levels(studycourse):